;Example to recall the backpropagation networks trained for the 
;phonemes /o/ /n/ /f/, that represent the words "on" and "off"

;This test case uses "on" test case 1 as the recall file and outputs 
;to screen

(defrule transform_signal
  ( speech )
=>
  ( bind $?v (transform "tst_on1.pcm" 2 ) )
  ( printout t "Speech = " $?v crlf )
  ( assert ( load_ranges ))
)


;normalise the data as produced by the previous rule - the transformation
;program - the first step involves loading the ranges of each input into a
;multifield parameter

(defrule load_network_norm_ranges
  (load_ranges)
=>
  (assert ( network_input_ranges
   -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0
   -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0
   -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0
   -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0 -7.0  80.0
   -7.0  80.0 -7.0  80.0 )
  )
)


;the second step involves calling the normalisation function
	
(defrule norm_signal
  ( network_input_ranges $?in )
=>
  ( bind $?w (normalise "tst_on1.rcl" "tst_on1.rcn" 0 $?in ) )
  ( printout t "Normalise = " $?w crlf )
  ( assert ( on_off ))
)


;recall the networks using the data normalised in the previous rule
(defrule recall_nets
  ( on_off )
=>
  ( bind $?x ( recallbp "o_net.wgt" "tst_on1.rcn" ) )
  ( printout t "recall phoneme o = "$?x crlf )

  ( bind $?y ( recallbp "f_net.wgt" "tst_on1.rcn" ) )
  ( printout t "recall phoneme f = "$?y crlf )

  ( bind $?z ( recallbp "n_net.wgt" "tst_on1.rcn" ) )
  ( printout t "recall phoneme n = "$?z crlf )
)