;**************************************************************************
;                                 Hybrid system
;**************************************************************************
; The appliction is a Discission Support System to make recomendations on whether or
; not to buy or sello shares based on output from the neural nets, input from the
; user, and a number of business rules.
;**************************************************************************

(deffacts initial
    (start))

(defrule hybrid_system
  ?step1 <- (start)
=>
  ; get input from user on the political and economic
  ; climates.
  (printout t "Is the economic climate good? " )
  (bind ?x (read t))
  (bind ?res (str-compare ?x "yes"))
  (if (= ?res 0)  then                   
                      (assert (economic climate good))
                   else           
                      (assert (economic climate bad)))
  (printout t " " crlf )
  (printout t "Is the political climate good? " )
  (bind ?x (read t))
  (bind ?res (str-compare ?x "yes"))
  (if (= ?res 0) then 
                      (assert (political climate good))
                    else
                      (assert (political climate bad)))
  ( printout t " " crlf )
  ; Get the current and one past value of the time
  ; series to be passed to the network.
  (printout t "Enter the current value of the index: ")
  (bind ?current_price (read t))
  (printout t  crlf  "Yesterdays value of the index: ")
  (bind ?yesterdays_price (read t))
  (printout t crlf)
  (bind $?net_input ?current_price ?yesterdays_price)
   ; normalise data, initialise a net, train it and then - recall
   ;(printout "Normalisation of the price data is in progress....")
   ;(bind $?status (normalise "c:\\hybrid\\stock\\stock2l.raw" "c:\\hybrid\\stock\\stock2l.trn" "s"))
   ;(printout t "Data has been normalised" crlf )
   (bind ?m (newbp "c:\\hybrid\\stock\\stockbp.wgt" 2 6 1)) 
   (printout t " A network has been initialised.." crlf "Be patient, training is in progress..." crlf) 
   (bind ?e (trainbp "c:\\hybrid\\stock\\stockbp.wgt" "c:\\hybrid\\stock\\stock2l.trn" "0.5"
"0.01" "0.05" 100)) 
  (printout t "Training has been accomplished" crlf)
 (bind ?predicted_price (recallbp "c:\\hybrid\\stock\\stockbp.wgt" $?net_input))
 (printout t "The predicted next value is: "  ?predicted_price crlf) 
 (retract ?step1) 
 (assert (step_2))
 (assert (current_price ?current_price))
 (assert (predicted_price ?predicted_price)))

; Categorises the predicted values from the neural network
(defrule hybrid_system_step_2_r1
  ?step2 <- (step_2)
  (current_price ?cp)
  (predicted_price ?pp)
=>
  (if (< ?cp ?pp) then
     (assert (predicted value is up))
     (retract ?step2)
     (assert (step_3))))

( defrule hybrid_system_step_2_r2
 ?step2 <- (step_2)
  (current_price ?cp)
  (predicted_price ?pp)
=>
  (if (= ?cp ?pp) then
    (assert (predicted value is same))
    (retract ?step2)
    (assert (step_3))))

( defrule hybrid_system_step_2_r3
  ?step2 <- (step_2)
  (current_price ?cp)
  (predicted_price ?pp)
=>
  (if (> ?cp ?pp) then
    (assert (predicted value is down))
    (assert (step_3))
    (retract ?step2)))

; apply business rules
( defrule hybrid_system_step_3_r1
  ?step3 <- (step_3)
  (political climate good)
  (economic climate good)
  (predicted value is up)
  =>
  (assert (buy shares))
  (assert (end_run))
  (retract ?step3))  

( defrule hybrid_system_step_3_r2
   ?step3 <- (step_3)
  (political climate bad)
  (economic climate good)
  (predicted value is up)  
=>
  (assert (buy shares))
  (retract ?step3)
  (assert (end_run)))

(defrule hybrid_system_step_3_r3
  ?step3 <- (step_3)
  (political climate good)
  (economic climate bad)
  (predicted value is same)  
=>
  (assert (hold shares))
  (retract ?step3)
  (assert (end_run)))
  
(defrule hybrid_system_step_3_r4
  ?step3 <- (step_3)
  (political climate bad)
  (economic climate bad)
  (predicted value is up)  
=>
  (assert (sell shares))
  (retract ?step3)
  (assert (end_run)))
  
(defrule hybrid_system_step_3_r4
  ?step3 <- (step_3)
  (political climate bad)
  (economic climate bad)
  (predicted value is down)  
=>
  (assert (sell shares))
  (retract ?step3)
  (assert (end_run)))

(defrule hybrid_system_step_3_r4
  ?step3 <- (step_3)
  (political climate bad)
  (economic climate bad)
  (predicted value is same)  
=>
  (assert (sell shares))
  (retract ?step3)
  (assert (end_run)))
    
(defrule hybrid_system_step_3_r5
  ?step3 <- (step_3)
  (political climate good)
  (economic climate good)
  (predicted value is down)  
=>
  (assert (hold shares))
  (retract ?step3)
  (assert (end_run)))  

(defrule hybrid_system_step_3_r5
  ?step3 <- (step_3)
  (political climate good)
  (economic climate good)
  (predicted value is same)  
=>
  (assert (hold shares))
  (retract ?step3)
  (assert (end_run)))  

; This rule prints out a recommendation of whether or not to buy, 
; sell, or hold shares based on the users perception of the political and economic
; climates and the neural nets prediction for the next
; value of the SE40.
( defrule end_of_run_1
  ?last_step <- (end_run)
  (buy shares)
=>
  (printout t crlf crlf "DECISION MADE BY THE SYSTEM" crlf)
  (printout t "Recommendation is to buy shares" crlf)
  (retract ?last_step))

( defrule end_of_run_2
  ?last_step <- (end_run)
  (sell shares)
=>
  (printout t crlf crlf "DECISION MADE BY THE SYSTEM" crlf)
  (printout t "Recommendation is to sell shares" crlf)
  (retract ?last_step))

( defrule end_of_run_3
  ?last_step <- (end_run)
  (hold shares)
=>
  (printout t crlf crlf "DECISION MADE BY THE SYSTEM" crlf)
  (printout t "Recommendation is to hold shares" crlf)
  (retract ?last_step))

                                            
