;Module 1: Predicting the weekly trend using FuzzyCLIPS

(deftemplate today ;today's index
    1000 4000
    (
	(very_small (1000 1) (1750 0))
	(small (1000 0) (1750 1) (2500 0))
	(average (1750 0) (2500 1) (3250 0))
	(large (2500 0) (3250 1) (4000 0))
	(very_large (3250 0) (4000 1))
    )
)

(deftemplate weekavg ;week's average
    1000 4000
    (
	(very_small (1000 1) (1750 0))
	(small (1000 0) (1750 1) (2500 0))
	(average (1750 0) (2500 1) (3250 0))
	(large (2500 0) (3250 1) (4000 0))
	(very_large (3250 0) (4000 1))
    )
)

(deftemplate today2 ;today's index
    1000 4000
    (
	(very_small (1000 1) (1750 0))
	(small (1000 0) (1750 1) (2500 0))
	(average (1750 0) (2500 1) (3250 0))
	(large (2500 0) (3250 1) (4000 0))
	(very_large (3250 0) (4000 1))
    )
)

(deftemplate weekavg2 ;week's average
    1000 4000
    (
	(very_small (1000 1) (1750 0))
	(small (1000 0) (1750 1) (2500 0))
	(average (1750 0) (2500 1) (3250 0))
	(large (2500 0) (3250 1) (4000 0))
	(very_large (3250 0) (4000 1))
    )
)
(deftemplate trend ;Output
    0 1
    (
	(bad (0 1) (1 0))
	(good (0 0) (1 1))
    )
)

(deffacts starting
          (invest))

(defrule rule1
	(today small)
	(weekavg large)
=>
	(assert (trend good))
)

(defrule rule2
	(today2 large)
	(weekavg2 small)
=>
	(assert (trend bad))
)

(defrule defuzzification
	?f <- (trend ?)
=>
 (bind ?t1 (moment-defuzzify ?f))
 (if (< ?t1 0.5) then
	(assert (week down))
  else
	(assert (week up))
 )
)

;Main System

(defrule invest_system
 (invest)
=>
;Get input from the user
 (printout t "Enter today's closing index (1000 to 4000): ")
 (bind ?i1 (read t))
 (printout t "Enter this week's average (1000 to 4000): ")
 (bind ?i4 (read t))
 (printout t "Enter last week's average (1000 to 4000): ")
 (bind ?i5 (read t))
 (printout t "Enter the four-week average (1000 to 4000): ")
 (bind ?i6 (read t))

;Asserting input for module 1

 (if (< ?i4 ?i1) then
	(assert (today (?i1 1)))
	(assert (weekavg (?i4 1)))
  else
	(assert (today2 (?i1 1)))
	(assert (weekavg2 (?i4 1)))
 )

;Module 2: Predicting the 4 week trend using FLIE

 (bind $?flie_input ?i1 ?i4 ?i5 ?i6)
 (bind ?t2 (fidfuzzy "a:\\invest.rul" $?flie_input))
 (assert (res ?t2))
)

(defrule bind_t2
 (res ?t2)
=>
 (if (< ?t2 0.5) then
	(assert (month down))
  else
	(assert (month up))
 )
)

;Module 3: Expert system to decide outcome

(defrule result_1
 (week down)
 (month down)
=>
 (printout t "Recommendation is to sell shares" crlf)
)

(defrule result_2
 (week up)
 (month down)
=>
 (printout t "Recommendation is to go short" crlf)
)

(defrule result_3
 (week down)
 (month up)
=>
 (printout t "Recommendation is to go long" crlf)
)

(defrule result_4
 (week up)
 (month up)
=>
 (printout t "Recommendation is to buy (long/short)" crlf)
)
