;                   
;  Iris Classifaction System                         
;    
					 
; A fuzzy system that classifies a given instance of iris data.
; Possible Iris types are:  1. Setosa  2. Versicolor  3. Viginica

;                                                              
; Rules                                                       
;                                                              

; the intro screen

(defrule initial_screen                                           
      (initial-fact)                                          
  =>                                                          
     (printout t "
     ***************************************************************** 
     *                                                               *
     *             *************************************             *
     *             *             Welcome               *             *
     *             *                                   *             *
     *             *               to                  *             * 
     *             *                                   *             * 
     *             *      Iris Classifaction System    *             *           
     *             *                                   *             *
     *             *                                   *             * 
     *             *************************************             * 
     ***************************************************************** 

")
     (assert (step_2))
)

; This rule and the following get input from the user

(defrule get_data
     ?step2 <- (step_2)
  =>   
     (printout t crlf "Enter in the attributes of a Iris flower in cm: ")       
     (printout t crlf crlf "Enter the Sepal length: " )
     (bind ?s_length(read))
     (printout t "Enter the Sepal width:  ")
     (bind ?s_width(read))
     (printout t "Enter the Petal length: ")
     (bind ?p_length(read))  
     (printout t "Enter the Petal width:  ") 
     (bind ?p_width(read))
     (bind $?flower ?s_length ?s_width ?p_length ?p_width)
     (assert (F $?flower)) 
     (retract ?step2)
     (assert (step_3))
)

(defrule classify_input
     ?step3 <- (step_3)
     (F $?flower)
    
=>
     (bind ?se1(fidfuzzy "c:\hybrid\fzzycope\iris\iris5m\iris121.rul" $?flower ))
     (bind ?ve1(fidfuzzy "c:\hybrid\fzzycope\iris\iris5m\iris122.rul" $?flower ))
     (bind ?vi1(fidfuzzy "c:\hybrid\fzzycope\iris\iris5m\iris123.rul" $?flower ))
     (bind ?se2(fidfuzzy "c:\hybrid\fzzycope\iris\iris5m\iris121r.rul" $?flower ))
     (bind ?ve2(fidfuzzy "c:\hybrid\fzzycope\iris\iris5m\iris122r.rul" $?flower ))
     (bind ?vi2(fidfuzzy "c:\hybrid\fzzycope\iris\iris5m\iris123r.rul" $?flower ))
     (bind $?results1 ?se1 ?ve1 ?vi1)
     (bind $?results2 ?se2 ?ve2 ?vi2)
     (assert (R1 $?results1))
     (assert (R2 $?results2))
     (retract ?step3)
     (assert (step_4))    
)

(defrule display_results
     ?step4 <- (step_4)
     (R1 $?results1)
     (R2 $?results2)
=>
     (printout t crlf "Classification Results:" crlf)
     (printout t "Results 1: Setosa   Versicolor   Viginica" crlf)
     (printout t $?results1 crlf)
     (printout t "Results 2: Setosa   Versicolor   Viginica" crlf)
     (printout t $?results2 crlf)
     (printout t crlf "Enter 'Q' to Quit: ")
     (bind ?answer(read))
     (bind ?res (str-compare ?answer "Q"))
     (retract ?step4)
     (if (<> ?res 0) then (assert (step_2))
		     else (printout t crlf "*  Iris Classification - BY!  *" crlf))
)
