; FUZZY BACK PROPAGATION EXAMPLES
( defrule FuzzyBPNet
  ( start )
=>
  ( bind $?status (newbp "a:\\fuzz2bp.wgt" 8 40 6) )
  ( printout t "Network Created (1=ok) = " $?status crlf )
  ( assert (bpexists) )
)

( defrule  fuzzifyIrisData
  ( start )
=>
  ( bind $?status ( fuzzify "c:\\test\\bpiris.trn" "a:\\fz2Iris.trn" 2 ) )
  ( printout t "Training file Fuzzified (1=ok) = " $?status crlf)
  ( assert (fileFuzzified) )
)

( defrule TrainIrisBP
  ( bpexists )
  ( fileFuzzified )
=>
  ( printout t "Training . . . " crlf )
  ( bind $?error (trainbp "a:\\fuzz2bp.wgt" "a:\\fz2Iris.trn" 1000) )
  ( printout t "Trained - Error = " $?error crlf )
  ( assert (bptrained) )
)

( defrule  ExtractIrisRules
  ( bptrained )
=>
  ( bind $?status ( extract "a:\\fuzz2bp.wgt" "a:\\fz2bp.rul" 4 1.0 ) )
  ( printout t "Extracted (1=ok) = " $?status crlf)
)

( defrule LoadBPMF_2Sets
  ( bptrained )
=>
  ( assert ( BPInputSets
	     0.788 0.212  0.25 0.75  0.965 0.035  0.958 0.042
	     0.364 0.636  0.6  0.4   0.404 0.596  0.417 0.583
	     0.576 0.424  0.6  0.4   0.316 0.684  0.042 0.958 )
  )
)

( defrule Recall_to_MF
  ( BPInputSets $?in)
=>
  ( bind $?out (recallbp "a:\\fuzz2bp.wgt" $?in) )
  ( printout t "Recall activations are " $?out crlf )
)

( defrule Recall_to_File
  ( bptrained )
=>
  ( bind $?out (recallbp "a:\\fuzz2bp.wgt" "a:\\fuzz2bp.rcl" "a:\\fuzz2bp.out") )
  ( printout t "Recall status is (1=ok) " $?out crlf )
)
