(deftemplate Risk
 0  1
 (
  (Low (0 1) (0.1 0.7) (0.2 0.3) (0.3 0))
  (Average (0.2 0) (0.3 0.5) (0.4 0.8) (0.5 1) (0.6 0.5)
           (0.7 0.2) (0.8 0))
  (High (0.5 0) (0.7 0.3) (0.8 0.7) (0.9 1) (1 1))
 ))


(deftemplate Return
 0 0.3
 (
  (Low (0 1) (0.02 0.3) (0.04 0))
  (Average (0.03 0.1) (0.04 0.4) (0.05 1) (0.06 0.75)
           (0.07 0.4) (0.08 0.1) (0.09 0))
  (High (0.07 0.1) (0.08 0.3) (0.09 0.8) (0.1 1) (0.3 1)) 
)) 



(deftemplate Amount
 0 300 $000s
 (
  (Small (0 1) (5 0.8) (10 0.6) (15 0.4) (20 0.2) (25 0))
  (Average (20 0) (25 0.2) (30 0.4) (35 0.6) (40 0.8) (45 1)
           (50 0.8) (55 0.6) (60 0.4) (65 0.2) (70 0))
  (Large (50 0) (100 0.2) (150 0.4) (200 0.6) (250 0.8) (300 1))
))

(deftemplate Investment
 0 1
 (
  (Small (0 1) (0.06 0.8) (0.12 0.6) (0.18 0.4) (0.24 0.2)
         (0.3 0))
  (Average (0.1 0) (0.2 0.2) (0.3 0.4) (0.5 0.7) (0.6 1) 
          (0.7 0.3) (0.8 0))
  (Large (0.6 0) (0.7 0.2) (0.8 0.9) (0.9 1) (1 1))
))

(deffacts initial
    (start)
)

(defrule get_info
   ?step1 <- (start)
=> 
   (printout t "How much money do you have to invest" crlf)
   (printout t "Input the number of thousands (0 to 300) ")
   (bind ?amt (read t))
   (if (< ?amt 25) then (assert (Amount Small))
       else (if (< ?amt 70) then (assert (Amount Average))
            else (assert (Amount Large)))) 
   (printout t "What is the risk of the investment (0 to 1) ")
   (bind ?ris (read t))
   (if (< ?ris 0.3) then (assert (Risk Low))
       else (if (< ?ris 0.8) then (assert (Risk Average))
            else (assert (Risk High))))
   (printout t "What is the return from the " crlf)
   (printout t "investment (0 to 1) ")
   (bind ?ret (read t))
   (if (< ?ret 0.04) then (assert (Return Low))
       else (if (< ?ret 0.09) then (assert (Return Average))
            else (assert (Return High)))) 

)

(defrule Rule1
   (Risk Low)
   (Return Low)
   (Amount Small)
=>
   (assert (Investment Large))
)

(defrule Rule2
   (Risk Low)
   (Return Low)
   (Amount Average)
=>
   (assert (Investment Average))
)

(defrule Rule3
   (Risk Low)
   (Return Low)
   (Amount Large)
=> (assert (Investment Small))
)

(defrule Rule4
   (Risk Low)
   (Return Average)
   (Amount Small)
=>
   (assert (Investment Large))
)

(defrule Rule5
   (Risk Low)
   (Return Average)
   (Amount Average)
=>
   (assert (Investment Large))
)

(defrule Rule6
   (Risk Low)
   (Return Average)
   (Amount Large)
=>
   (assert (Investment Average))
)

(defrule Rule7
   (Risk Low)
   (Return High)
=>
   (assert (Investment Large))
)

(defrule Rule8
   (Risk Average)
   (Return Low)
   (Amount Small)
=>
   (assert (Investment Small))
)

(defrule Rule9
   (Risk Average)
   (Return Low)
   (Amount Average)
=>
   (assert (Investment Small))
)

(defrule Rule10
   (Risk Average)
   (Return Low)
   (Amount Large)
=>
   (assert (Investment Average))
)

(defrule Rule11
   (Risk Average)
   (Return Average)
=>
   (assert (Investment Average))
)

(defrule Rule12
   (Risk Average)
   (Return High)
   (Amount Small)
=> 
   (assert (Investment Average))
)

(defrule Rule13
   (Risk Average)
   (Return High)
   (Amount Average)
=>
   (assert (Investment Large))
)

(defrule Rule14
   (Risk Average)
   (Return High)
   (Amount Large)
=>
   (assert (Investment Large))
)

(defrule Rule15
   (Risk High)
   (Return Low)
=>
   (assert (Investment Small))
)

(defrule Rule16
   (Risk High)
   (Return Average)
   (Amount Small)
=>
   (assert (Investment Small))
)

(defrule Rule17
   (Risk High)
   (Return Average)
   (Amount Average)
=>
   (assert (Investment Small))
)

(defrule Rule18
   (Risk High)
   (Return Average)
   (Amount Large)
=>
   (assert (Investment Average))
)

(defrule Rule19
   (Risk High)
   (Return High)
   (Amount Small)
=>
   (assert (Investment Average))
)

(defrule Rule20
   (Risk High)
   (Return High)
   (Amount Average)
=>
   (assert (Investment Large))
)

(defrule Rule21
   (Risk High)
   (Return High)
   (Amount Large)
=>
   (assert (Investment Large))
)

(defrule defuzzify
   ?out <- (Investment ?)
=>
   (bind ?de_fz (moment-defuzzify ?out))
   (printout t "Proportion to invest is " ?de_fz crlf)
)   


